
package mainpackage;

import java.io.File;
import java.io.*;
import java.util.HashMap;
import java.util.Map;
import parser.*;
import syntaxtree.*;
import visitor.*;


public class Main
{
    public static FileWriter writer;
    public static Map<String, Integer> maxTemps = new HashMap();
    
    public static void main(String[] args)
    {
        if (args.length < 1)
        {
            System.err.println("Usage: java Main <file1> <file2> ... <fileN>");
            System.exit(1);
        }

        FileInputStream fis = null;
        for (String arg : args)
        {
            maxTemps.clear();
            
            try
            {
                writer = new FileWriter(new File(arg.replace(".pg", ".spg")));
                
                fis = new FileInputStream(arg);
                PigletParser parser = new PigletParser(fis);
                Goal tree = parser.Goal();

                MaxTempVisitor maxtv = new MaxTempVisitor();
                PigletVisitor pigv = new PigletVisitor();
                
                tree.accept(maxtv, null);                
                tree.accept(pigv, null);
            }
            catch (ParseException ex)
            {
                System.err.println(ex.getMessage());
            }
            catch (FileNotFoundException ex)
            {
                System.err.println(ex.getMessage());
            }
            catch (IOException ex)
            {
                System.err.println(ex.getMessage());
            }
            finally
            {              
                try
                {
                    if (fis != null)
                    {
                        fis.close();
                    }
                    if (writer != null)
                    {
                        writer.flush();
                        writer.close();
                    }                    
                }
                catch (IOException ex)
                {
                    System.err.println(ex.getMessage());
                }
            }
        }        
    }
    
}
